# std::_Deque_iterator< _Tp, _Ref, _Ptr > Struct Template Reference

List of all members.

## Detailed Description

### template<typename _Tp, typename _Ref, typename _Ptr>
struct std::_Deque_iterator< _Tp, _Ref, _Ptr >

Quite a bit of intelligence here. Much of the functionality of deque is actually passed off to this class. A deque holds two of these internally, marking its valid range. Access to elements is done as offsets of either of those two, relying on operator overloading in this class.

Definition at line 102 of file stl_deque.h.

## Public Types

- typedef _Tp ** _Map_pointer
- typedef _Deque_iterator _Self
- typedef _Deque_iterator< _Tp,
  const _Tp &, const _Tp * > const_iterator
- typedef ptrdiff_t difference_type
- typedef _Deque_iterator< _Tp,
  _Tp &, _Tp * > iterator
- typedef std::random_access_iterator_tag iterator_category
- typedef _Ptr pointer
- typedef _Ref reference
- typedef size_t size_type
- typedef _Tp value_type

## Public Member Functions

- _Deque_iterator (const iterator &__x)
- _Deque_iterator ()
- _Deque_iterator (_Tp *__x, _Map_pointer __y)
- void _M_set_node (_Map_pointer __new_node)
- reference operator * () const
- _Self operator+ (difference_type __n) const
- _Self operator++ (int)
- _Self & operator++ ()
- _Self & operator+= (difference_type __n)
- _Self operator- (difference_type __n) const
- _Self operator-- (int)
- _Self & operator-- ()
- _Self & operator-= (difference_type __n)
- pointer operator-> () const
- reference operator[] (difference_type __n) const

## Static Public Member Functions

- static size_t _S_buffer_size ()

## Public Attributes

- _Tp * _M_cur
- _Tp * _M_first
- _Tp * _M_last
- _Map_pointer _M_node

The documentation for this struct was generated from the following file:

- stl_deque.h